package dev.pfaff.altargui.debug.events;

import dev.pfaff.log4truth.format.AppendTo;
import dev.pfaff.log4truth.format.Appender;

import static java.util.FormatProcessor.FMT;

public sealed interface LayoutEvent extends WidgetStateEvent {
	long key();

	boolean needed();

	@Override
	default void appendTo(Appender appender) {
		String litA = "Layout[key=";
		String litB = ", needed=";
		String litC = "]";
		String className = getClass().getSimpleName();
		String keyString = FMT."%016x\{key()}";
		String neededString = String.valueOf(needed());
		appender.reserve(className.length() +
						 litA.length() +
						 keyString.length() +
						 litB.length() +
						 neededString.length() +
						 litC.length());
		appender.append(className);
		appender.append(litA);
		appender.append(keyString);
		appender.append(litB);
		appender.append(neededString);
		appender.append(litC);
	}

	record Stencil(long key, boolean needed) implements LayoutEvent {
		@Override
		public String toString() {
			return AppendTo.toString(this);
		}
	}

	record Trace(long key, boolean needed) implements LayoutEvent {
		@Override
		public String toString() {
			return AppendTo.toString(this);
		}
	}

	record Scissor(long key, boolean needed) implements LayoutEvent {
		@Override
		public String toString() {
			return AppendTo.toString(this);
		}
	}
}
